/*-- 
	Tutorial 04
	Author: Maikel

	In this tutorial the player will be familiarized with some melee weapons.
--*/


static guide; // guide object.

protected func Initialize()
{
	// Environment 
	PlaceGrass(85);
	Cloud->Place(15);
	// Place some trees in a forest shape.
	//PlaceForest([Tree_Coniferous], 0, LandscapeHeight() / 2 + 50, nil, true);

	SproutBerryBush->Place();
	//var time = CreateObject(Environment_Time);
	//time->SetTime(22*60);
	//time->SetCycleSpeed(0);
	//Sound("WindLoop", true, 40, nil, 1);

		var x = 25 + Random(40);
		var lorry = CreateObjectAbove(Lorry, x, FindHeight(x) - 20);
		lorry->CreateContents(Wood, 6);
		lorry->CreateContents(Metal, 4);
		lorry->CreateContents(Rock, 4);
		lorry->CreateContents(Dynamite, 4);
		lorry->CreateContents(Pickaxe);
	
	// Goal: Melee, all opponents must be killed.
	var goal = CreateObject(Goal_ResourceExtraction, 0, 0, NO_OWNER);
	goal->SetResource("Gold");
	
	// Script player as opponent.
	SetMaxPlayer(3);
	CreateScriptPlayer("$NameOpponent$", RGB(40,30,20), nil, CSPF_FixedAttributes);
	return;
}



protected func InitializePlayer(int plr)
{
	// Initiate script player.
	if (GetPlayerType(plr) == C4PT_Script)
		return InitializeScriptPlayer(plr);
	
	// Clonk to position
	var clonk = GetCrew(plr, 0);
	clonk->SetPosition(35, 325);
	clonk->CreateContents(Shovel);
	clonk->CreateContents(Hammer);
	clonk->CreateContents(Axe);
	
	GivePlayerBasicKnowledge(plr);
	GivePlayerSpecificKnowledge(plr, [Sword]);
	GivePlayerSpecificKnowledge(plr, [Bow]);
	GivePlayerSpecificKnowledge(plr, [Arrow]);
	GivePlayerSpecificKnowledge(plr, [Armory]);
	return;
}

private func InitializeScriptPlayer(int plr)
{
	// Remove old crew.
	var index = 0;
	while (GetCrew(plr, index))
	{
		GetCrew(plr, index)->RemoveObject();
		index++;
	}

	// Underground, stands on a ledge
	var bowman = CreateObjectAbove(Clonk, 381, 502, plr);
	bowman->MakeCrewMember(plr);
	bowman->SetMaxEnergy(45);
	bowman->CreateContents(Bow)->CreateContents(Arrow);
	bowman->AI_GuardArea(310, 470, 150, 100);
	AddEffect("IntContentRemoval", bowman, 100, 0);
	bowman->AddEnergyBar();
	
	// Fourth section: Opponent with sword and shield.
	var swordman = CreateObjectAbove(Clonk, 395, 550, plr);
	swordman->MakeCrewMember(plr);
	swordman->SetMaxEnergy(60);
	swordman->CreateContents(Shield);
	swordman->CreateContents(Sword);
	swordman->AI_GuardArea(315, 530, 150, 60);
	AddEffect("IntContentRemoval", swordman, 100, 0);
	swordman->AddEnergyBar();
	
	// Fourth section: Opponent with sword and shield.
	var swordman2 = CreateObjectAbove(Clonk, 264, 510, plr);
	swordman2->MakeCrewMember(plr);
	swordman2->SetMaxEnergy(60);
	swordman2->CreateContents(Shield);
	swordman2->CreateContents(Sword);
	swordman->AI_GuardArea(170,500, 120, 25);
	AddEffect("IntContentRemoval", swordman2, 100, 0);
	swordman2->AddEnergyBar();
	return;
}