/*-- 
	Tutorial 04
	Author: Maikel

	In this tutorial the player will be familiarized with some melee weapons.
--*/

protected func Initialize()
{
	// Environment 
	PlaceGrass(85);
	Cloud->Place(15);
	// Place some trees in a forest shape.
	//PlaceForest([Tree_Coniferous], 0, LandscapeHeight() / 2 + 50, nil, true);

	SproutBerryBush->Place();
	// Branches as a nice additional source of wood.
	Branch->Place(30 + Random(8));
	//var time = CreateObject(Environment_Time);
	//time->SetTime(22*60);
	//time->SetCycleSpeed(0);
	//Sound("WindLoop", true, 40, nil, 1);

		var x = 290;
		var lorry = CreateObjectAbove(Lorry, x, FindHeight(x) - 20);
		lorry->CreateContents(Wood, 6);
		lorry->CreateContents(Metal, 4);
		lorry->CreateContents(Rock, 4);
		lorry->CreateContents(Dynamite, 4);
		lorry->CreateContents(Pickaxe);
	
	// Goal: Melee, all opponents must be killed.
	var goal = CreateObject(Goal_ResourceExtraction, 0, 0, NO_OWNER);
	goal->SetResource("Gold");
	
	CreateObject(Rule_TeamAccount);
	CreateObject(Rule_BuyAtFlagpole);
	CreateObject(Rule_NoPowerNeed);
	
	// Script player as opponent.
	SetMaxPlayer(3);
	CreateScriptPlayer("$NameOpponent$", RGB(40,30,20), nil, CSPF_FixedAttributes);
	return;
}



protected func InitializePlayer(int plr)
{
	// Initiate script player.
	if (GetPlayerType(plr) == C4PT_Script)
		return InitializeScriptPlayer(plr);
		
	// Set zoom range.
	SetPlayerZoomByViewRange(plr, 500, nil, PLRZOOM_Direct | PLRZOOM_LimitMax);
	SetPlayerViewLock(plr, true);
		
	// Clonk to position
	var clonk = GetCrew(plr, 0);
	clonk->SetPosition(300, 1500);
	clonk->CreateContents(Shovel);
	clonk->CreateContents(Hammer);
	clonk->CreateContents(Axe);
	
	GivePlayerBasicKnowledge(plr);
	GivePlayerPumpingKnowledge(plr);
	GivePlayerAdvancedKnowledge(plr);
	GivePlayerArtilleryKnowledge(plr);
	
	// Give the player the elementary base materials.
	GivePlayerElementaryBaseMaterial(plr);
	
	SetPlrKnowledge(plr, WindGenerator, 1);
	SetPlrKnowledge(plr, SteamEngine, 1);
	SetPlrKnowledge(plr, Compensator, 1);
	
	return;
}

private func InitializeScriptPlayer(int plr)
{
	// Remove old crew.
	var index = 0;
	while (GetCrew(plr, index))
	{
		GetCrew(plr, index)->RemoveObject();
		index++;
	}

	PlaceSwordsman(810, 790, plr);
	
	PlaceBowman(842, 734, plr);
	PlaceBowman(607, 734, plr);
	
	PlaceSwordsman(1027, 740, plr);
	
	PlaceBowman(800, 640, plr);
	
	PlaceSwordsman(730, 640, plr);
	PlaceSwordsman(600, 622, plr);
	
	PlaceBowman(1070, 530, plr);
	
	PlaceBowman(990, 470, plr);
	
	PlaceBowman(960, 327, plr);
	
	PlaceSwordsman(690, 445, plr);
	
	PlaceBowman(780, 380, plr);
	
	PlaceSwordsman(587, 373, plr);
	
	PlaceBowman(613, 310, plr);
	
	return;
}

func PlaceBowman(int x, int y, int plr)
{
	var bowman = CreateObjectAbove(Clonk, x, y, plr);
	bowman->MakeCrewMember(plr);
	bowman->SetMaxEnergy(45);
	bowman->CreateContents(Bow)->CreateContents(Arrow);
	bowman->AI_GuardArea(x-100, y-100, 200, 200);
	AddEffect("IntContentRemoval", bowman, 100, 0);
	bowman->AddEnergyBar();
}

func PlaceSwordsman(int x, int y, int plr)
{
	var swordman = CreateObjectAbove(Clonk, x, y, plr);
	swordman->MakeCrewMember(plr);
	swordman->SetMaxEnergy(60);
	swordman->CreateContents(Shield);
	swordman->CreateContents(Sword);
	swordman->AI_GuardArea(x-100, y-100, 200, 200);
	AddEffect("IntContentRemoval", swordman, 100, 0);
	swordman->AddEnergyBar();
}